#include <stdio.h>
#include "..\uboard\uboard.h"

void CallBack(WORD pos, WORD buf_size)
{
    if (buf_size==0) return;
    printf("%c",0xd);   //step back to start of line
    float percent=0;
    if (pos==0)
    {
        printf("% 3d %%",0);
    }
    else
    {
        percent=float(pos*100/buf_size);
        printf("% 3d %%",int(percent));
    }
}

int main(int param,char *argv[])
{
    if(param==3)
	{
		if (argv[1][0]=='r')
		{
            set_Port(unsigned char(atoi(argv[2])));
	  		set_delay(0x20);
	  		printf("reset on %hxh",set_Port(0xFF));
			reset();
			printf(" ready\n\n");
			return 1;
		} 
	}

	if(param!=4)
	{
		char path[300];
        sprintf(path,"%s",argv[0]);
        char *exe=NULL;
        for (int x=0; x<300;x++)
        {
            if (path[x]=='\0') break;
                else if (path[x]=='\\') exe=&path[x+1];
        }
        printf("\n\n");
		printf("\n use: %s binaryfile 0/1/2 1..255\n",exe);
		printf("\n  or: %s r 0/1/2\n",exe);
		printf("\n     -binaryfile: file for upload");
		printf("\n     -r         : call reset");		
		printf("\n     -0/1/2     : 0=(278h) / 1=(378h) / 2=(3BCh)");
		printf("\n     -1..255    : upload-speed (1=quick .. 255=very slow)\n\n");
	}
	else
	{
        set_Port(unsigned char(atoi(argv[2])));
        printf("use port %hX\n", set_Port(0xFF) );    //read only Port-adr.
        if (!read_file(argv[1]) )
        printf("%s\n",get_LastError() );
        else
        {
            setCallback( CallBack );
            set_delay(unsigned char(atoi(argv[3])));
            printf("read %d bytes [%hX]\n",get_bufsize(), get_chsum() );
            write_ram();
        }
	    printf("\nreset on %hxh",set_Port(3));
	    reset();
	    printf(" ready\n\n");
        return 1;
    }
    return 0;
}